<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib">
    <h:form id="globalForm">
        <!--<s:token allowMultiplePosts="true"/>-->
        <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
        <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                       value="#{deferredTransactionBrowser.filter.urlParameters}"/>
        <script>
            updateUrl("globalForm:filterUrlParameters");
            jq162("#globalForm\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("globalForm:filterUrlParameters");
                    });

        </script>
        <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
            <ui:include src="/filter/filter.xhtml">
                <ui:param name="filterWidth" value="240"/>
                <ui:param name="filter" value="#{deferredTransactionBrowser.filter}"/>
                <ui:param name="filterId" value="status"/>
                <ui:param name="filterName" value="#{messages['gazelle.simulator.pam.Status']}"/>
                <ui:param name="filterForm" value="globalForm"/>
            </ui:include>
            <ui:include src="/filter/filter.xhtml">
                <ui:param name="filterWidth" value="240"/>
                <ui:param name="filter" value="#{deferredTransactionBrowser.filter}"/>
                <ui:param name="filterId" value="init"/>
                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.patientmanager.InitiatingGateway']}"/>
                <ui:param name="filterForm" value="globalForm"/>
            </ui:include>
            <ui:include src="/filter/filter.xhtml">
                <ui:param name="filterWidth" value="240"/>
                <ui:param name="filter" value="#{deferredTransactionBrowser.filter}"/>
                <ui:param name="filterId" value="resp"/>
                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.patientmanager.RespondingGateway']}"/>
                <ui:param name="filterForm" value="globalForm"/>
            </ui:include>
            <ui:include src="/filter/filterDate.xhtml">
                <ui:param name="filter" value="#{deferredTransactionBrowser.filter}"/>
                <ui:param name="filterId" value="queryTS"/>
                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.patientmanager.QueryTimestamp']}"/>
                <ui:param name="filterForm" value="globalForm"/>
            </ui:include>
            <ui:include src="/filter/filterDate.xhtml">
                <ui:param name="filter" value="#{deferredTransactionBrowser.filter}"/>
                <ui:param name="filterId" value="responseTS"/>
                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.patientmanager.ResponseTimestamp']}"/>
                <ui:param name="filterForm" value="globalForm"/>
            </ui:include>
            <ui:define name="filter_buttons">
                <a4j:commandLink title="#{messages['gazelle.pam.RefreshResults']}"
                                 render="globalForm">
                    <span class="gzl-icon-refresh"></span>
                </a4j:commandLink>
                <a4j:commandLink title="#{messages['gazelle.pam.ResetCriteria']}"
                                 actionListener="#{deferredTransactionBrowser.reset()}"
                                 render="globalForm">
                    <span class="gzl-icon-times-circle"></span>
                </a4j:commandLink>
            </ui:define>
        </ui:decorate>
        <ui:decorate template="/layout/panels/_panel_title.xhtml">
            <ui:define name="panel_title">#{messages['net.ihe.gazelle.patientmanager.DeferredMessages']}</ui:define>
            <s:div id="messageListDiv">
                <ui:decorate template="/layout/form/_checkbox.xhtml">
                    <h:selectBooleanCheckbox value="#{deferredTransactionBrowser.autoRefresh}">
                        <a4j:ajax event="change" render="messageListDiv"/>
                    </h:selectBooleanCheckbox>
                    #{messages['net.ihe.gazelle.patientmanager.AutorefreshTheListOfMessages']}
                </ui:decorate>
                <a4j:poll id="poll" interval="1000"
                          actionListener="#{deferredTransactionBrowser.isEverythingProcessed()}"
                          enabled="#{deferredTransactionBrowser.autoRefresh}"
                          render="messageListDiv"/>
                #{dataTableStateHolder.setDescendingOn('query.timestamp')}
                <rich:dataTable value="#{deferredTransactionBrowser.getDeferredTransactionFiltered()}"
                                var="dt" rows="#{dataScrollerMemory.numberOfResultsPerPage}"
                                id="messageList" render="ds">
                    <g:column
                            sortBy="#{'status'}"
                            sortOrder="#{dataTableStateHolder.sortOrders['status']}">
                        <ui:define name="header">#{messages['gazelle.simulator.pam.Status']}</ui:define>
                        <h:outputText value="#{dt.status.label}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.InitiatingGateway']}</ui:define>
                        <h:outputText value="#{dt.query.request.issuer}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.RespondingGateway']}</ui:define>
                        <h:outputText value="#{dt.query.response.issuer}"/>
                    </g:column>
                    <g:column
                            sortBy="#{'query.timestamp'}"
                            sortOrder="#{dataTableStateHolder.sortOrders['query.timestamp']}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.Query']} #{messages['gazelle.simu.Timestamp']}
                        </ui:define>
                        <g:date value="#{dt.query.timestamp}"/>
                    </g:column>
                    <g:column
                            sortBy="#{'response.timestamp'}"
                            sortOrder="#{dataTableStateHolder.sortOrders['response.timestamp']}">
                        <ui:define name="header">#{messages['net.ihe.gazelle.pam.Response']} #{messages['gazelle.simu.Timestamp']}
                        </ui:define>
                        <g:date value="#{dt.response.timestamp}"
                                rendered="#{dt.response != null}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.patgen.Actions']}</ui:define>
                        <div class="gzl-never-wrap">
                            <h:outputLink value="#{deferredTransactionBrowser.permanentLink(dt.query)}"
                                          title="#{messages['net.ihe.gazelle.patientmanager.DetailsOnQuery']}">
                    <span class="gzl-icon-stack">
                        <i class="fa-arrow-right gzl-icon-stack-1x gzl-text-green"/>
                        <i class="gzl-icon-search gzl-icon-stack-1x"/>
                    </span>
                            </h:outputLink>
                            <h:outputLink value="#{deferredTransactionBrowser.permanentLink(dt.response)}"
                                          title="#{messages['net.ihe.gazelle.patientmanager.DetailsOnResponse']}"
                                          rendered="#{dt.response != null}">
                    <span class="gzl-icon-stack">
                        <i class="fa-arrow-left gzl-icon-stack-1x gzl-text-red"/>
                      <i class="gzl-icon-search gzl-icon-stack-1x"/>
                    </span>
                            </h:outputLink>
                            <ui:insert name="moreActions"/>
                        </div>
                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="messageList"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
            </s:div>
        </ui:decorate>
    </h:form>
</ui:composition>